#ifndef __WLAPI_H__
#define __WLAPI_H__
//#define __FreeBSD__
//#define LINUX_DRIVER
/* Uncomment the line, if you would like to debug API */
/* #define WLAPI_DEBUG */

/* Uncomment the line, if the driver runs unstablely on notebook */
#define WL_SLOWDOWN_IO
#ifdef __FreeBSD__
/*-------------------------- FreeBSD Begin ----------------------------*/
#  define  FREEBSD_DRIVER
#  include <machine/cpufunc.h>
#  include <sys/param.h>			/* for printf() */
#  include <sys/systm.h>			/* for printf() */
#  include <net/ethernet.h> 		/* for ETHER_MAX_LEN */

#  define SLOW_DOWN_IO				__asm__ __volatile__("outb %al,$0x80")
   /* inb(), and outb() are defined within i386/include/cpufunc.h */
#  ifdef  WL_SLOWDOWN_IO
#	 define InB(port)				  inb(port)
#	 define OutB(data, port)		  { outb((port), (data)); SLOW_DOWN_IO; }
#	 define OutB_P(data, port)		  { outb((port), (data)); SLOW_DOWN_IO; SLOW_DOWN_IO; }
#	 define OutSB(port, addr, size)   { outsb((port), (addr), (size)); SLOW_DOWN_IO; }
#  else
#	 define InB(port)				  inb(port)
#	 define OutB(data, port)		  outb((port), (data));
#	 define OutB_P(data, port)		  { outb((port), (data)); SLOW_DOWN_IO; }
#	 define OutSB(port, addr, size)   outsb((port), (addr), (size))
#  endif /* !SLOW_DOWN_IO */
#  define printk  printf

   void* memset(void *pBuf, int nValue, size_t nSize);	/* my own */
/*---------------------------- FreeBSD End ----------------------------*/
#else
/*---------------------------- Linux Begin ----------------------------*/
#  define  LINUX_DRIVER
#  include <linux/netdevice.h>			/* for enet_statistics */
#  include <linux/kernel.h>
#  include <linux/string.h>
#  include <asm/io.h>
#  ifdef WL_PCMCIA
#	 include <pcmcia/version.h>
#	 include <pcmcia/cs_types.h>
#	 include <pcmcia/cs.h>
#	 include <pcmcia/cistpl.h>
#	 include <pcmcia/ds.h>
#  endif /* End of WL_PCMCIA */

#  define ETHER_MIN_LEN 			64
#  define ETHER_MAX_LEN 			1518

   /* inb(), and outb() are defined within include/asm/io.h */
#  ifdef  WL_SLOWDOWN_IO
#	 define InB(port)				  inb(port)
#	 define OutB(data, port)		  { outb((data), (port)); SLOW_DOWN_IO; }
#	 define OutB_P(data, port)		  { outb_p((data), (port)); SLOW_DOWN_IO; }
#	 define OutSB(port, addr, size)   { outsb((port), (addr), (size)); SLOW_DOWN_IO; }
#  else
#	 define InB(port)				  inb(port)
#	 define OutB(data, port)		  outb((data), (port))
#	 define OutB_P(data, port)		  outb_p((data), (port))
#	 define OutSB(port, addr, size)   outsb((port), (addr), (size))
#  endif
/*---------------------------- Linux End   ----------------------------*/
#endif

#ifdef __alpha__
typedef unsigned int			DWORD;
#else
typedef unsigned long		DWORD;
#endif

typedef unsigned short			WORD;
typedef unsigned char			BYTE;
typedef int 					BOOL;

// define for WLA 2.0

#define USHORT WORD
#define UCHAR  unsigned char
#define BlockSize 256
//***************************************************************
// ID for input Signals of DRIVER block
// bit[7-5] is block ID: 000
// bit[4-0] is signal ID
//***************************************************************
#define Alarm				0x00
#define MdConfirm			0x01
#define MdIndicate			0x02
#define AssocConfirm		0x03
#define AssocIndicate		0x04
#define AutheConfirm		0x05
#define AutheIndicate		0x06
#define DeautheConfirm		0x07
#define DeautheIndicate 	0x08
#define DisassocConfirm 	0x09
#define DisassocIndicate	0x0A
#define GetConfirm			0x0B
#define JoinConfirm 		0x0C
#define PowermgtConfirm 	0x0D
#define ReassocConfirm		0x0E
#define ReassocIndicate 	0x0F
#define ScanConfirm 		0x10
#define SetConfirm			0x11
#define StartConfirm		0x12
#define ResyncConfirm		0x13
#define SiteConfirm 		0x14
#define SaveConfirm 		0x15
#define RFtestConfirm		0x16

//***************************************************************
// ID for input Signals of MLME block
// bit[7-5] is block ID: 010
// bit[4-0] is signal ID
//***************************************************************
#define AssocRequest	   0x20
#define AutheRequest	   0x21
#define DeautheRequest	   0x22
#define DisassocRequest    0x23
#define GetRequest		   0x24
#define JoinRequest 	   0x25
#define PowermgtRequest    0x26
#define ReassocRequest	   0x27
#define ScanRequest 	   0x28
#define SetRequest		   0x29
#define StartRequest	   0x2A
#define MdRequest		   0x2B
#define ResyncRequest	   0x2C
#define SiteRequest 	   0x2D
#define SaveRequest 	   0x2E
#define RFtestRequest	   0x2F

#define MmConfirm		   0x60
#define MmIndicate		   0x61

#define Infrastructure	   0
#define Independent 	   1
#define Any_bss 		   2
#define ActiveScan		   0
#define PassiveScan 	   1
#define TxResult_Success	0
#define TxResult_NoBss		1
#define TxResult_retryLimit 2

#define Open_System 		0
#define Share_Key			1

#define EtherII 0
#define Ether802_3e 1
#define Ether802_3f 2

#define SUCCESS 	0
#define INVALID 	1
#define TIMEOUT 	2
#define REFUSED 	3
#define MANY_REQ	4
#define ALREADYBSS	5

#define UNSPEC		1
#define PRE_AU_NOV	2
#define DEAUTH3 	3
#define DIASS2INA	4
#define CLASS2		5
#define CLASS3		6
#define DIASS8		7
#define NOAUTH9 	8
#define RESERVED10	9
// MIB Attrib
#define aStationID							  0
#define aAuthenticationAlogrithms			  1
#define aAuthenticationType 				  2
#define aMediumOccupancyLimit				  3
#define aCFPollable 						  4
#define aCFPPeriod							  5
#define aCFPMaxDuration 					  6
#define aAuthenticationResponseTimeout		  7
#define aReceiveDTIMs						  8
#define aPrivacyOptionImplemented			  9
#define aPrivacyInvoked 					 10
#define aWEPDefaultKeys 					 11
#define aWEPDefaultKeyID					 12
#define aWEPKeyMappings 					 13
#define aWEPKeyMappingLength				 14
#define aExcludeUnencrypted 				 15
#define aWEPICVErrorCount					 16
#define aWEPUndecryptableCount				 17
#define aWEPExcludedCount					 18
#define aMacAddress 						 19
#define aGroup_Addresses					 20
#define aRTSThreshold						 21
#define aShortRetryLimit					 22
#define aLongRetryLimit 					 23
#define aFragmentationThreshold 			 24
#define aMaxTransmitMSDULifetime			 25
#define aMaxReceiveLifetime 				 26
#define aManufacturerID 					 27
#define aProductID							 28
#define aTransmittedFragmentCount			 29
#define aMulticastTransmittedFrameCount 	 30
#define aFailedCount						 31
#define aReceiveFragmentCount				 32
#define aMulticastReceivedCount 			 33
#define aFCSErrorCount						 34
#define aRetryCount 						 35
#define aMultipleRetryCount 				 36
#define aRTSSuccessCount					 37
#define aRTSFailureCount					 38
#define aACKFailureCount					 39
#define aFrameDuplicateCount				 40
#define aPHYType							 41
#define aRegDomainsSupport					 42
#define aCurrentRegDomain					 43
#define aSlotTime							 44
#define aCCATime							 45
#define aRxTxTurnaroundTime 				 46
#define aTxPLCPDelay						 47
#define aRxTxSwitchTime 					 48
#define aTxRampOnTime						 49
#define aTxRFDelay							 50
#define aSIFSTime							 51
#define aRxRFDelay							 52
#define aRxPLCPDelay						 53
#define aMACProcessingDelay 				 54
#define aTxRampOffTime						 55
#define aPreambleLength 					 56
#define aPLCPHeaderLength					 57
#define aMPDUDurationFactor 				 58
#define aAirPropagationTime 				 59
#define aTempType							 60
#define aCWmin								 61
#define aCWmax								 62
#define aSupportDataRatesTx 				 63
#define aSupportDataRatesRx 				 64
#define aMPDUMaxLength						 65
#define aSupportTxAntennas					 66
#define aCurrentTxAntenna					 67
#define aSupportRxAntennas					 68
#define aDiversitySupport					 69
#define aDiversitySelectionRx				 70
#define aNumberSupportedPowerLevels 		 71
#define aTxPowerLevel1						 72
#define aTxPowerLevel2						 73
#define aTxPowerLevel3						 74
#define aTxPowerLevel4						 75
#define aTxPowerLevel5						 76
#define aTxPowerLevel6						 77
#define aTxPowerLevel7						 78
#define aTxPowerLevel8						 79
#define aCurrentTxPowerLevel				 80
#define aCurrentChannel 					 81
#define aCCAModeSupported					 82
#define aCurrentCCAMode 					 83
#define aEDThreshold						 84
#define aSynthesizerLocked					 85
#define aCurrentPowerState					 86
#define aDozeTurnonTime 					 87
#define aRCR33								 88
#define aDefaultChannel 					 89
#define aSSID								 90
#define aPowerMgmtEnable					 91
#define aNetworkCapability					 92
#define aRouting							 93



typedef struct t_Segment256{
	USHORT	NextSegment;
	UCHAR	 data[254];
} Segment256;
typedef struct t_Segment32{
	USHORT	NextSegment;
	UCHAR	 data[30];
} Segment32;
typedef struct t_TxHeader{
	USHORT	XmitCount;
	UCHAR	SYNC[16];
	USHORT	SFD;
	UCHAR	SIGNAL;
	UCHAR	SERVICE;
	USHORT	LENGTH;
	USHORT	CRC16;
	USHORT	FrameControl;
	USHORT	DurationID;
	UCHAR	Address1[6];
	UCHAR	Address2[6];
	UCHAR	Address3[6];
	USHORT	SequenceControl;
	UCHAR	Address4[6];
} TxHeader;
typedef struct t_RxHeader{
	USHORT	RxNextBlock;
	USHORT	RxNextFrameBlock;
	UCHAR	RxBlockCtrl;
	UCHAR	RxNextFrame;
	UCHAR	RxNextFrame1;
	UCHAR	RSSI;
	UCHAR	Time[8];
	UCHAR	Signal;
	UCHAR	Service;
	USHORT	Length;
	USHORT	CRC16;
	USHORT	FrameControl;
	USHORT	Duration;
	UCHAR	Address1[6];
	UCHAR	Address2[6];
	UCHAR	Address3[6];
	USHORT	Sequence;
	UCHAR	Address4[6];
}RxHeader;

typedef struct t_StartReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR BSSType;
	USHORT	BeaconPeriod;
	USHORT	DTIMPeriod;
	USHORT	ProbeDelay;
	USHORT	CapablilityInfo;
	UCHAR SSID[34];
	UCHAR BSSBasicRateSet[10];
	UCHAR OperationalRateSet[10];
	UCHAR CFpset[8];
	UCHAR PHYpset[3];
	UCHAR IBSSpset[4];
} StartReq;

typedef struct t_AssocReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Timeout;
	USHORT	CapInfo;
	USHORT	ListenInterval;
	UCHAR MacAddress[6];
} AssocReq;
typedef struct t_AssocConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} AssocConf;
typedef struct t_AssocInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR MacAddress[6];
} AssocInd;
typedef struct t_AutheReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Type;
	USHORT	Timeout;
	UCHAR MacAddress[6];
} AutheReq;
typedef struct t_AutheConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Type;
	USHORT	Status;
	UCHAR  MacAddress[6];
} AutheConf;
typedef struct t_AutheInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Type;
	UCHAR MacAddress[6];
} AutheInd;
typedef struct t_DeautheReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Reason;
	UCHAR  MacAddress[6];
} DeautheReq;
typedef struct t_DeautheConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
	UCHAR  MacAddress[6];
} DeautheConf;
typedef struct t_DeautheInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Reason;
	UCHAR  MacAddress[6];
} DeautheInd;
typedef struct t_DisassocReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Reason;
	UCHAR  MacAddress[6];
} DisassocReq;
typedef struct t_DisassocConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} DisassocConf;
typedef struct t_DisassocInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Reason;
	UCHAR  MacAddress[6];
} DisassocInd;
typedef struct t_GetReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	MibAtrib;
} GetReq;
typedef struct t_GetConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	MibStatus;
	USHORT	MibAtrib;
	UCHAR	MibValue[100];
} GetConf;
typedef struct t_JoinReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	UCHAR OperationalRateSet[10];
	USHORT	Reserved2;
	USHORT	Timeout;
	USHORT	ProbeDelay;
	UCHAR Timestamp[8];
	UCHAR LocalTime[8];
	USHORT	BeaconPeriod;
	USHORT	DTIMPeriod;
	USHORT	CapablilityInfo;
	UCHAR BSSType;
	UCHAR  BSSID[6];
	UCHAR SSID[34];
	UCHAR PHYpset[3];
	UCHAR CFpset[8];
	UCHAR IBSSpset[4];
	UCHAR BSSBasicRateSet[10];
} JoinReq;
typedef struct t_JoinConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} JoinConf;

typedef struct t_PowerMgtReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR PwrSave;
	UCHAR WakeUp;
	UCHAR ReceiveDTIMs;
} PowerMgtReq;
typedef struct t_PowerMgtConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} PowerMgtConf;

typedef struct t_ReassocReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Timeout;
	USHORT	CapInfo;
	USHORT	ListInt;
	UCHAR  MacAddress[6];
} ReassocReq;
typedef struct t_ReassocConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} ReassocConf;
typedef struct t_ReassocInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	UCHAR  MacAddress[6];
} ReassocInd;
typedef struct t_ResetReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	UCHAR SetMIB;
	UCHAR  MacAddress[6];
} ResetReq;
typedef struct t_ResetConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} ResetConf;
typedef struct t_ScanReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR BSSType;
	USHORT	ProbeDelay;
	USHORT	MinChannelTime;
	USHORT	MaxChannelTime;
	UCHAR ChannelList[14];
	UCHAR  BSSID[6];
	UCHAR SSID[34];
	UCHAR ScanType;
} ScanReq;
typedef struct t_ScanConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
	UCHAR Timestamp[8];
	UCHAR LocalTime[8];
	USHORT	BeaconPeriod;
	USHORT	DTIMPeriod;
	USHORT	CapablilityInfo;
	UCHAR BSSType;
	UCHAR BSSID[6];
	UCHAR SSID[34];
	UCHAR PHYpset[3];
	UCHAR CFpset[8];
	UCHAR IBSSpset[4];
	UCHAR BSSBasicRateSet[10];
	UCHAR RSSI;
} ScanConf;

typedef struct t_SetReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	MibAtrib;
	USHORT	MibValue;
} SetReq;
typedef struct t_SetConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	MibStatus;
	USHORT	MibAtrib;
} SetConf;
typedef struct t_StartConf{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Status;
} StartConf;
typedef struct t_MdReq{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Routing;
	USHORT	Data;
	USHORT	Size;
	UCHAR Priority;
	UCHAR ServiceClass;
	UCHAR DAddress[6];
	UCHAR SAddress[6];
} MdReq;
typedef struct t_MdInd{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Routing;
	USHORT	Data;
	USHORT	Size;
	UCHAR Reception;
	UCHAR Priority;
	UCHAR ServiceClass;
	UCHAR DAddress[6];
	UCHAR SAddress[6];
} MdInd;
typedef struct t_MdCon{
	USHORT	NextBlock;
	UCHAR SignalID;
	UCHAR Reserved;
	USHORT	Data;
	UCHAR Status;
	UCHAR Priority;
	UCHAR ServiceClass;
} MdCon;

typedef struct t_ResyncReq{
	USHORT	NextBlock;
	UCHAR SignalID;
} ResyncReq;

typedef struct t_ResyncConf{
	USHORT	NextBlock;
	UCHAR	SignalID;
	UCHAR	Status;
} ResyncConf;

typedef struct t_SiteReq{
	USHORT	NextBlock;
	UCHAR SignalID;
} SiteReq;
typedef struct t_SiteConf{
	USHORT	NextBlock;
	UCHAR	SignalID;
	UCHAR	Reserved;
	USHORT	Status;
	UCHAR	RSSI[101];
} SiteConf;
typedef struct t_SaveReq{
	USHORT	NextBlock;
	UCHAR	SignalID;
} SaveReq;
typedef struct t_SaveConf{
	USHORT	NextBlock;
	UCHAR	SignalID;
	UCHAR	Status;
} SaveConf;


/*----------------------- WLAPI_DEBUG definition-----------------------*/
#ifdef	WLAPI_DEBUG
#  define WL_DBG_API			0x00000001L
#  define WL_DBG_INIT			0x00000002L
#  define WL_DBG_EXCEPT 		0x00000004L
#  define WL_DBG_ROAM			0x00000008L
#  define WL_DBG_PNP			0x00000100L

#  define WL_STAT_API_FUNC		0x000000FFL
#  define WL_STAT_INIT			0x00000001L
#  define WL_STAT_TX_PKT		0x00000002L
#  define WL_STAT_RX_LOOK		0x00000004L
#  define WL_STAT_RX_RECV		0x00000008L
#  define WL_STAT_RX_DONE		0x00000010L

#  define WL_STAT_LOCK_FUNC 	0x00000F00L
#  define WL_STAT_LOCK_SUTRO	0x00000100L
#  define WL_STAT_UNLOCK_SUTRO	0x00000200L

#  define WL_STAT_MIB_FUNC		0x0000F000L
#  define WL_STAT_GET_MIB		0x00001000L
#  define WL_STAT_SET_MIB		0x00002000L

#  define WL_STAT_TRIVIAL_FUNC	0x00FF0000L
#  define WL_STAT_BLK_INTR		0x00010000L
#  define WL_STAT_UNBLK_INTR	0x00020000L
#  define WL_STAT_INT_WLA		0x00040000L
#  define WL_STAT_SET_WLA		0x00080000L
#  define WL_STAT_GET_WLA		0x00100000L
#  define WL_STAT_FLASH_READ	0x00200000L
#  define WL_STAT_PNP_PROBE 	0x00400000L
#  define WL_STAT_PNP_SET		0x00800000L

   extern DWORD WL_DbFlag;
#  define TRACE_API(format, args...)  \
			{ if (WL_DbFlag & WL_DBG_API) printk(format , ## args); }
#  define TRACE_INIT(format, args...)  \
			{ if (WL_DbFlag & WL_DBG_INIT) printk(format , ## args); }
#  define TRACE_EXCEPT(format, args...)  \
			{ if (WL_DbFlag & WL_DBG_EXCEPT) printk(format , ## args); }
#  define TRACE_ROAM(format, args...)  \
			{ if (WL_DbFlag & WL_DBG_ROAM) printk(format , ## args); }
#  define TRACE_PNP(format, args...)  \
			{ if (WL_DbFlag & WL_DBG_PNP) printk(format , ## args); }
#  define TRACE(format, args...)	printk(format , ## args);
#  define ASSERT(x) \
			{ if (!(x)) printk("FILE:%s LINE:%d, ASSERT FAILED\n", __FILE__, __LINE__); }
#  define WHEN_WLAPI_DEBUG(x) x
#  define ASSERT_STAT(x) \
			{ (x) ? 0 : printk("FILE:%s LINE:%d, ASSERT FAILED! STAT=0x%lx\n", __FILE__, __LINE__, pAdaptor->ulDbgStat); }
#else
#  define TRACE_API(format, args...)
#  define TRACE_INIT(format, args...)
#  define TRACE_EXCEPT(format, args...)
#  define TRACE_ROAM(format, args...)
#  define TRACE_PNP(format, args...)
#  define TRACE(format, args...)
#  define ASSERT(x)
#  define WHEN_WLAPI_DEBUG(x)
#  define ASSERT_STAT(x)
#endif

/* For rough constant delay */
#define NOPLOOP(n)	   { int x=0; while(x++<n) SLOW_DOWN_IO; }

/**************************************************************************/
/* !!!!!!!		  All structures must be tight alignmented		  !!!!!!!!*/
/**************************************************************************/
#pragma pack (1)

/* Ethernet MAC Address, BSS_ID, or ESS_ID */
/* With this, we may simply write "x=y;" instead of "memcpy(x, y, 6);" */
/* It's more efficiency with compiler's optimization and more clearly  */
typedef struct _MADDR {
	BYTE	b0;
	BYTE	b1;
	BYTE	b2;
	BYTE	b3;
	BYTE	b4;
	BYTE	b5;
} MADDR;

/* Instead of calling memcmp(), use those macro to speed up! */
/* To port to platforms that care alignment, I do not do DWORD comparing */
#define MA_ISEQUAL(x, y)   ( (x).b0 == (y).b0 && (x).b1 == (y).b1 && (x).b2 == (y).b2 && (x).b3 == (y).b3 && (x).b4 == (y).b4 && (x).b5 == (y).b5 )

#define MA_ISZERO(x)	   ( (x).b0 == 0 && (x).b1 == 0 && (x).b2 == 0 && (x).b3 == 0 && (x).b4 == 0 && (x).b5 == 0 )

#ifndef TRUE
#  define  FALSE  0
#  define  TRUE   (!FALSE)
#endif

/* */
/* Definitions for supporting clone adapters. */
/* */

/* Max TX_DESC reserved */
#define MAX_TX_DESC_RESERVED	20

/* Timeout for beacon (unit: ms.) */
#define BEACON_TIMEOUT			1000

/* */
/* Valid value ranges for the IoBaseAddress. */
/* */
#define MIN_IOBASEADDR 0x0100
#define MAX_IOBASEADDR 0xffc0

#define WL_IO_REGION			0x10

/* */
/* Default value for Adapter->IoBaseAddr */
/* */
#define DEFAULT_IOBASEADDR (PVOID)0x280

/* */
/* Default value for Adapter->InterruptNumber */
/* */
#define DEFAULT_INTERRUPTNUMBER 11


/* System Interface Registers (SIR space) */
#define NIC_GCR 	((BYTE)0x00)   /* SIR0 - General Configuration Register */
#define NIC_BSS 	((BYTE)0x01)   /* SIR1 - Bank Switching Select Register */
#define NIC_LMAL	((BYTE)0x02)   /* SIR2 - Local Memory Address Register [7:0] */
#define NIC_LMAH	((BYTE)0x03)   /* SIR3 - Local Memory Address Register [14:8] */
#define NIC_IODPA	((BYTE)0x04)   /* SIR4 - I/O Data Port A */
#define NIC_IODPB	((BYTE)0x05)   /* SIR5 - I/O Data Port B */
#define NIC_IODPC	((BYTE)0x06)   /* SIR6 - I/O Data Port C */
#define NIC_IODPD	((BYTE)0x07)   /* SIR7 - I/O Data Port D */


/* Bits in GCR */
#define GCR_SWRESET 	((BYTE)0x80)
#define GCR_CORESET 	((BYTE)0x40)
#define GCR_DISPWDN 	((BYTE)0x20)
#define GCR_ECWAIT		((BYTE)0x10)
#define GCR_ECINT		((BYTE)0x08)
#define GCR_INT2EC		((BYTE)0x04)
#define GCR_ENECINT 	((BYTE)0x02)
#define GCR_DAM 		((BYTE)0x01)


/* Bits in BSS (Bank Switching Select Register) */
#define BSS_FPAGE0		((BYTE)0x20)   /* Flash memory page0 */
#define BSS_FPAGE1		((BYTE)0x28)
#define BSS_FPAGE2		((BYTE)0x30)
#define BSS_FPAGE3		((BYTE)0x38)
#define BSS_SPAGE0		((BYTE)0x00)   /* SRAM page0 */
#define BSS_SPAGE1		((BYTE)0x08)
#define BSS_SPAGE2		((BYTE)0x10)
#define BSS_SPAGE3		((BYTE)0x18)


/**************************************************************** */
/* Define Driver Interface */
/**************************************************************** */

/*
 * Refer IEEE 802.11
 */

/* */
/* Tx packet header, include PLCP and MPDU */
/* */

/*
 * Tx PLCP Header
 */
typedef struct _TX_PLCP_HDR {
	BYTE	SYNC[16];
	WORD	SFD;
	BYTE	SIGNAL;
	BYTE	SERVICE;
	WORD	LENGTH;
	WORD	CRC16;
} TX_PLCP_HDR, *PTX_PLCP_HDR;

/*
 * Data Frame MAC Header (IEEE 802.11)
 */
typedef struct _DATA_MAC_HDR {
	WORD	FrameControl;
	WORD	DurationID;
	MADDR	Address1;
	MADDR	Address2;
	MADDR	Address3;
	WORD	SequenceControl;
	MADDR	Address4;
} DATA_MAC_HDR, *PDATA_MAC_HDR;

typedef struct _TX_HEADER{
	TX_PLCP_HDR 	PlcpHdr;
	DATA_MAC_HDR	MacHdr;
} TX_HEADER, * PTX_HEADER;

#define FRAME_CTRL_INFRA	((WORD) 0x0108)
#define FRAME_CTRL_ADHOC	((WORD) 0x0008)
#define FRAME_CTRL_AP		((WORD) 0x0208)
#define FRAME_CTRL_IAP		((WORD) 0x0308)
#define FRAME_CTRL_BEACON_LO   ((BYTE) 0x80)

/* */
/* Result of Ne2000IndicatePacket(). */
/* */
typedef enum {
	INDICATE_OK,
	SKIPPED,
	ABORT,
	CARD_BAD
} INDICATE_STATUS;


/**************************************************************************/
/* !!!!!!!				Restore old alignment setup 			  !!!!!!!!*/
/**************************************************************************/
#pragma pack ()


/*

   Reserve the beginning Tx space for descriptor use.


   TxBlockOffset -->  *----*----*----*----* \
	(TxFreeDesc)	  |  0 |  1 |  2 |	3 |  \
					  |  4 |  5 |  6 |	7 |   |
					  |  8 |  9 | 10 | 11 |   TX_DESC * 20
					  | 12 | 13 | 14 | 15 |   |
					  | 16 | 17 | 18 | 19 |  /
   TxBufferBegin -->  *----*----*----*----* /
   (TxBufferHead)	  | 				  |
   (TxBufferTail)	  | 				  |
					  |    Send Buffer	  |
					  | 				  |
					  | 				  |
					  *-------------------*
   TxBufferEnd -------------------------/

*/

typedef struct _WL_Adaptor {
	int 	nBaseAddr;
	MADDR	MacAddress;
	WORD	uTxBufferSize;
	WORD	uTxBufferHead;
	WORD	uTxBufferTail;
	WORD	uTxBufferCount;
	WORD	uESBQReqStart;
	WORD	uESBQReqEnd;
	WORD	uESBQReqHead;
	WORD	uESBQReqTail;
	WORD	uESBQConfirmStart;
	WORD	uESBQConfirmEnd;
	WORD	uESBQConfirm;
    MADDR   BSSID;
	BYTE	LLCType;
	BYTE	NetworkType;
    BYTE    ESSID[34];
    BYTE    KeepESSID[34];
	BYTE	EtherType;
    BYTE    Channel;
    BYTE    DefaultChannel;
    WORD    StartSegment;
    WORD    BSSCount;
    WORD    JoinStaBSS;
    BYTE    CapablilityInfo;
    BYTE    AdHocTimes;
    BOOL    CardStart;
    ScanConf BSSset[20];
    BYTE    DriverState;
    BYTE    FrequencyDomain;
    BYTE    Version[2];
#ifdef LINUX_DRIVER
	struct	enet_statistics stat;	/* linux/if_ether.h */
#	ifdef WL_PCMCIA
		dev_node_t node;			/* PCMCIA only */
#	endif /* End of WL_PCMCIA */
#endif /* End of LINUX_DRIVER */

	WHEN_WLAPI_DEBUG(DWORD	ulDbgStat);
} WL_Adaptor, *PWL_Adaptor;

/*
 * API for accessing WL24xx SUTRO
 */
int  TraceNothing(const char *cpszFormat, ...);
void TraceBuf(void *pBuf, int nSize);
BOOL WL_GetFlashMacAddress(WL_Adaptor *pAdaptor);
void WL_FlashOutB(WL_Adaptor *pAdaptor, WORD uPage, WORD uAddr, BYTE cData);
void WL_FlashOutB128(WL_Adaptor *pAdaptor, WORD uPage, WORD uAddr, char *pbuf);
BYTE WL_FlashInB(WL_Adaptor *pAdaptor, WORD uPage, WORD uAddr);
void WL_FlashInSB(WL_Adaptor *pAdaptor, WORD uPage, WORD uSrc, void *pDest, int nSize);
WORD WL_GetFlashID(WL_Adaptor *pAdaptor);
BOOL WL_FlashWriteOk(WL_Adaptor *pAdaptor);
BOOL WL_FlashEraseSector(WL_Adaptor *pAdaptor, WORD uSector);
BOOL WL_FlashWriteByte(WL_Adaptor *pAdaptor, WORD uPage, WORD uAddr, BYTE cData);
BOOL WL_FlashWriteByte128(WL_Adaptor *pAdaptor, WORD uPage, WORD uAddr, char *pbuf);
BOOL WL_WriteFlash(WL_Adaptor *pAdaptor,unsigned char *pbuf,WORD uLen);
BOOL WL_BlockInterrupt(WL_Adaptor *pAdaptor);
BOOL WL_UnBlockInterrupt(WL_Adaptor *pAdaptor);
BOOL WL_HoldSutro(WL_Adaptor *pAdaptor);
BOOL WL_UnHoldSutro(WL_Adaptor *pAdaptor);
void WL_InteruptWla(WL_Adaptor *pAdaptor);
void WL_SetToWla(WL_Adaptor *pAdaptor, WORD uDest, void *pSrc, int nSize);
void WL_GetFromWla(WL_Adaptor *pAdaptor, WORD uSrc, void *pDest, int nSize);
void WL_SetDescNext(WL_Adaptor *pAdaptor, WORD uDesc, DWORD ulNext);
DWORD WL_GetDescNext(WL_Adaptor *pAdaptor, WORD uDesc);
WORD WL_GetTxDesc(WL_Adaptor *pAdaptor);
void WL_FreeTxDesc(WL_Adaptor *pAdaptor, WORD uDesc);
BOOL WL_LockSutro(WL_Adaptor *pAdaptor);
void WL_UnlockSutro(WL_Adaptor *pAdaptor);
WORD WL_GetTxBuffer(WL_Adaptor *pAdaptor, WORD uDataLen);
void WL_FreeTxBuffer(WL_Adaptor *pAdaptor, WORD uPtr);
BOOL WL_EnableReceiver(WL_Adaptor *pAdaptor);
BOOL WL_InitTx(WL_Adaptor *pAdaptor);
void WL_GetMibValue(WL_Adaptor *pAdaptor, WORD cIndex);
void WL_SetMibValue(WL_Adaptor *pAdaptor, WORD cIndex, void *pSrc, BYTE cSize);
BOOL WL_ResetBoard(WL_Adaptor *pAdaptor);
BOOL WL_InitFirmware(WL_Adaptor *pAdaptor);
BOOL WL_SendPkt(WL_Adaptor *pAdaptor, BYTE *pData, WORD uLen);
WORD WL_Receive(WL_Adaptor *pAdaptor, BYTE *pBuf, WORD uSize);
BOOL WL_ReceiveDone(WL_Adaptor *pAdaptor);
int  WL_ReceiveDataLook(WL_Adaptor *pAdaptor);
WORD WL_ReceiveData(WL_Adaptor *pAdaptor, BYTE *pBuf, WORD uSize);
BOOL WL_ReceiveDataDone(WL_Adaptor *pAdaptor);
void WL_Roaming(WL_Adaptor *pAdaptor);
BOOL WL_ESBQRequestTest(WL_Adaptor *pAdaptor);
void WL_ESBQRequest(WL_Adaptor *pAdaptor, WORD *ptr);
void WL_ESBQRequestFree(WL_Adaptor *pAdaptor);
BOOL WL_ESBQConfirm(WL_Adaptor *pAdaptor);
void WL_ESBQConfirmDone(WL_Adaptor *pAdaptor);
BOOL MgmtStart(WL_Adaptor *pAdaptor);
BOOL MgmtScan(WL_Adaptor *pAdaptor,WORD ChannelTime);
BOOL MgmtJoin(WL_Adaptor *pAdaptor,WORD stas);
BOOL MgmtAuthetication(WL_Adaptor *pAdaptor);
BOOL MgmtAssociation(WL_Adaptor *pAdaptor);
BOOL MgmtResync(WL_Adaptor *pAdaptor);
void MgmtScanConfirm(WL_Adaptor *pAdaptor,WORD Address);
void MgmtJoinConfirm(WL_Adaptor *pAdaptor,WORD Address);
void MgmtResyncConfirm(WL_Adaptor *pAdaptor);

#endif /* __WLAPI_H__ */
